/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	CREAT.C	--	CONTAINS CREAT, OPEN, READ, WRITE, AND CLOSE	*/

/*	IBM must be set to 1 or 0.	*/

#define	IBM		1

/*	STANDARD FILE NUMBERS	*/

#define	STDIN	0
#define	STDOUT	1
#define	STDERR	2
#define STDPRN	4
#define FIRSTD	5

/*	FILES contains status of all files	*/

/*	CP/M	codes	*/

#define	OPEN_CODE	15
#define CLOSE_CODE	16
#define DELETE_CODE	19
#define MAKE_CODE	22
#define READ_CODE	20
#define WRITE_CODE	21
#define SETDMA_CODE	26
#define RREAD_CODE	33
#define SIZE_CODE	35

#define CONTC	3
#define BS		8
#define LF		10
#define CR		13
#define CONTX	24
#define CONTZ	26
#define RUB		127

#define UNUSED	0
#define	OPENI	1
#define OPENO	2
#define OPENA	3
#define OPENU	4

#define	NFILE	8

#define FDRIVE	0
#define	FNAME	1
#define	FEXT	9
#define	FBLOCK	12
#define FSIZE	16
#define	FRECORD	32
#define	FLOC	33
#define FCBLEN	37
#define	FILELEN	176

struct { char mode, plusoff, dirty;
		unsigned bufnext, bufend, currec, numrec;
		char fcb[FCBLEN],fragment[128]; } *_file;

char _files[NFILE][FILELEN],stopz[NFILE+FIRSTD];
unsigned _fileat[NFILE],_msnum[NFILE];
int _ungotten[NFILE+FIRSTD]={-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1};
int _oldfile=99;		/* last file scanf'ed	*/
#if	IBM
extern char _msdos2;
#endif

union {long dword; unsigned word;};
struct {unsigned loword,hiword;};



/*	CREAT			filenum=creat(name)		*/

creat(name)
	char *name; {
	int  fnum;
	char err;

	fnum=_newfile(name,2);
	if (fnum > STDPRN) {
		_file=_fileat[fnum-FIRSTD]=&_files[fnum-FIRSTD][0];

/*	do a msdos-2 create	*/
#if	IBM
		if (_msdos2) {
			err=_msnum[fnum-FIRSTD]=_creat(name);
			}

		else {
#endif
			_os(DELETE_CODE,_file->fcb);
			err=_os(MAKE_CODE,_file->fcb);
#if	IBM
			}
#endif
		if (err == 255) fnum=-1;
		else {
			_file->mode=OPENA;
			_file->plusoff=_file->dirty=0;
			_file->bufnext=_file->bufend=_file->fragment;
			_file->currec=_file->numrec=0;
#if IBM
			(&_file->fcb[FBLOCK])->word=0;
			_file->fcb[FRECORD]=0;
#endif
			}
		}
	return fnum | 0x800;
	}


/*	OPEN			filenum=open(name,mode)		*/

open(name,mod)
	char *name,mod; {
	int  fnum;
	char err,zmod;

	zmod=mod;
	if (mod > 2) mod-=3;	/* mode 3 means test for control Z */

	if (mod > 2) return -1;

	fnum=_newfile(name,mod);
	if (fnum > STDPRN) {
		_file=_fileat[fnum-FIRSTD]=&_files[fnum-FIRSTD][0];

/*	do an msdos-2 open	*/
#if	IBM
		if (_msdos2) {
			err=_msnum[fnum-FIRSTD]=_open(name,mod);
			}
		else {
#endif
			err=_os(OPEN_CODE,_file->fcb);
#if	IBM
			}
#endif
		if (err == 255) fnum=-1;
		else {
			stopz[fnum]=zmod >=3;
#if IBM
			(&_file->fcb[FBLOCK])->word=0;
			_file->fcb[FRECORD]=0;
			_file->plusoff=_file->fcb[FSIZE] & 127;
			_file->numrec=((&_file->fcb[FSIZE])->dword) >> 7;
#else
			_os(SIZE_CODE,_file->fcb);
			_file->plusoff=0;
			_file->numrec=(&_file->fcb[FLOC])->word;
#endif
			if (_file->plusoff == 0 && _file->numrec) {
				_file->plusoff=128;
				_file->numrec--;
				}
			_file->currec=0;
			_file->bufnext=_file->bufend=_file->fragment;
			_file->dirty=0;
			_file->mode=mod+1;
			}
		}
	return fnum | 0x800;
	}


/*		_newfile puts a file name into an unallocated fcb	*/

_newfile(name,mod)
	char *name,mod; {
	int  i,j;
	char *ptr,*uptr,uname[65];

	ptr=uname;
	do
		if (*name >= 'a' && *name <= 'z') *ptr=*name++-32;
		else *ptr=*name++;
	while (*ptr++);
	if (_streq(uname,"CON:")) return mod == 0 ? STDIN: STDOUT;
	if (_streq(uname,"PRN:") || _streq(uname,"LST:")) return STDPRN;
	for (i=0; i < NFILE; i++) {
		if (_files[i][0] == 0) {
			ptr=_files[i];
			for (j=0; j < FCBLEN; j++)
				ptr->fcb[j]=0;
			uptr=uname;
			if (uname[1] == ':') {
				ptr->fcb[FDRIVE]=uname[0]-'@';
				uptr+=2;
				}
			j=FNAME;
			while (j < FEXT) {
				if (*uptr != '.' && *uptr) ptr->fcb[j++]=*uptr++;
				else ptr->fcb[j++]=' ';
				}
			if (*uptr == '.') uptr++;
			while (j < FEXT+3) {
				if (*uptr) ptr->fcb[j++]=*uptr++;
				else ptr->fcb[j++]=' ';
				}
			return i+FIRSTD;
			}
		}
	return -1;
	}



_streq(stra,strb)
	char *stra,*strb; {

	do {
		if (*stra != *strb++) return 0;
		}
	while (*stra++);
	return 1;
	}



/*	READ			charactors read = read(filenum,buffer,nbytes);	*/

read(filenum,buffer,nbytes)
	int  filenum;
	unsigned nbytes;
	char *buffer; {
	char i,*fbuf;
	unsigned  num,needed,nround;
	int ch;

	fbuf=buffer;
	filenum &=0x7ff;

	if (filenum < 0 || filenum > NFILE+STDPRN || filenum == STDPRN) return -1;
	needed=nbytes;
	if (filenum <= STDERR) {
		while (needed) {
			if ((ch=getc(filenum)) < 0 || ch == CONTZ || ch == '\n') break;
			if (ch != CR) {
				*buffer++=ch;
				needed--;
				}
			}
		return nbytes-needed;
		}

	_file=_fileat[filenum-FIRSTD];
	i=_file->mode;
	if (i == UNUSED || i == OPENO) return -1;

	num=_file->bufend-_file->bufnext;
	if (num) {
		if (_file->dirty && _file->currec > _file->numrec) return 0;
		if (num > nbytes) num=nbytes;
		if (num) {
			_move(num,_file->bufnext,buffer);
			_file->bufnext+=num;
			buffer+=num;
			needed-=num;
			}
		}
	while (needed >= 128) {
#if	IBM
		if (_msdos2) {
			num=_read(_msnum[filenum-FIRSTD],buffer,needed);
			if (num == -1) return -1;
			needed-=num;
			goto goback;
			}
#endif

		num=_cread(_file,buffer);
		needed-=num;
		if (num != 128) goto goback;
		buffer+=num;
		}

	if (needed) {
		_file->bufnext=_file->fragment;
#if	IBM
		if (_msdos2) {
			num=_read(_msnum[filenum-FIRSTD],_file->fragment,128);
			if (num == -1) return -1;
			}
		else {
#endif
			num=_cread(_file,_file->fragment,128);
#if	IBM
			}	
#endif
		_file->bufend=_file->fragment+num;
		if (num > needed) num=needed;
		if (num) {
			_move(num,_file->bufnext,buffer);
			_file->bufnext+=num;
			needed-=num;
			}
		}
goback:
	num=needed=nbytes-needed;
	if (stopz[filenum]) {
		for (needed=0; needed < num && fbuf[needed] != CONTZ; needed++) ;
		}
	return needed;
	}

_cread(ptr,buffer)
	char *ptr,*buffer; {
	int  rval;

	if (ptr->dirty) {
		if (_cwrite(ptr,buffer) < 128) return 0;
		ptr->dirty=0;
		}

	_os(SETDMA_CODE,buffer);
	rval=_os(READ_CODE,ptr->fcb);

#if IBM
	if (rval == 0) rval=128;
	else if (rval == 1) rval=0;
	else if (rval == 3) rval=(ptr->fcb[FSIZE]) &127;
	else rval=0;
	if (rval < 128) return rval;

#else
	if (rval != 0) return 0;
	rval=128;
#endif
	if (ptr->numrec == ptr->currec) {
		buffer+=128;
		while (rval && *--buffer == CONTZ)
			rval--;
		ptr->plusoff=rval;
		}
	ptr->currec++;
	return rval;
	}


/*	WRITE			charactors written = write(filenum,buffer,nbytes);	*/

write(filenum,buffer,nbytes)
	int  filenum;
	unsigned nbytes;
	char *buffer; {
	char mod;
	unsigned  num,needed;
	int inlen;

	filenum &=0x7ff;
	if (filenum < 0 || filenum > NFILE+STDPRN) return -1;
	needed=nbytes;

	if (filenum <= STDERR) {
		while (needed--)
			putc(*buffer++,filenum);
		return nbytes;
		}
	if (filenum == STDPRN) {
		while (needed--)
			_os(5,*buffer++);
		return nbytes;
		}

	_file=_fileat[filenum-FIRSTD];
	mod=_file->mode;
	if (mod < OPENO) return -1;

	inlen=_file->bufend-_file->fragment;
	if (_file->bufend !=_file->fragment) _file->bufend=&_file->fragment[128];
	num=_file->bufend-_file->bufnext;
	if (num) {
		if (_file->dirty == 0) {
			_file->currec--;
			(&_file->fcb[FLOC])->dword=_file->currec;
#if	IBM
			if (_msdos2) _lseek(_msnum[filenum-FIRSTD],(long)-inlen,1);
			else {
#endif
				_os(SETDMA_CODE,_file->fragment);
				if (_os(RREAD_CODE,_file->fcb) != 0) return -1;
#if	IBM
				}
#endif
			_file->dirty=1;
			}
		if (num > nbytes) num=nbytes;
		if (num) {
			_move(num,buffer,_file->bufnext);
			_file->bufnext+=num;
			buffer+=num;
			needed-=num;
			if (_file->bufnext == _file->bufend) {
#if	IBM
				if (_msdos2) {
					if (_write(_msnum[filenum-FIRSTD],_file->fragment,128) == -1)
						return -1;
					}
				else {
#endif
					if (_cwrite(_file,_file->fragment) == 0) return -1;
#if	IBM
					}
#endif
				_file->bufnext=_file->bufend=_file->fragment;
				}
			}
		}

	while (needed >= 128) {
#if	IBM
		if (_msdos2) return _write(_msnum[filenum-FIRSTD],buffer,needed) == -1 ? -1: nbytes;
#endif
		num=_cwrite(_file,buffer);
		needed-=num;
		if (num < 128) return -1;
		buffer+=128;
		}

	if (needed) {
		if (mod != OPENA) {
#if	IBM
			if (_msdos2)
				return _write(_msnum[filenum-FIRSTD],buffer,needed) == -1 ? -1: nbytes;
#endif
			if (_file->currec < _file->numrec ||
				(_file->currec == _file->numrec && _file->plusoff)) {
				_os(SETDMA_CODE,_file->fragment);
				(&_file->fcb[FLOC])->dword=_file->currec;
				if (_os(RREAD_CODE,_file->fcb) != 0) return -1;
				}
			}
		_file->bufend+=128;
		_move(needed,buffer,_file->bufnext);
		_file->bufnext+=needed;
		_file->dirty=1;
		}
	return nbytes;
	}

_cwrite(ptr,buffer)
	char *ptr,*buffer; {
	int  rval;

	_os(SETDMA_CODE,buffer);
	rval=_os(WRITE_CODE,ptr->fcb);
	ptr->dirty=0;
	ptr->currec++;
	return (rval != 0)? 0: 128;
	}



/*	CLOSE			error = close(file number);	*/

close(filenum)
	int  filenum; {

	_oldfile=99;
	filenum &=0x7ff;
	if (filenum <= STDPRN) return 0;
	_file=_fileat[filenum-FIRSTD];
	if (filenum > NFILE+STDPRN || _file->mode == UNUSED) return -1;

	if (_fflush(filenum) == -1) return -1;
	_file->mode=UNUSED;
#if	IBM
	if (_msdos2) return _close(_msnum[filenum-FIRSTD]);
#endif
	return (_os(CLOSE_CODE,_file->fcb) == 255) ? -1: 0;
	}





_fflush(filenum)
	int  filenum; {
	char ngot;

	_file=_fileat[filenum-FIRSTD];
	if (_file->dirty) {
		ngot=_file->bufnext-_file->fragment;
#if	IBM
		if (_msdos2) {
			return _write(_msnum[filenum-FIRSTD],_file->fragment,ngot);
			}
#endif
		if (_file->numrec == _file->currec) {
			if (_file->plusoff == 128) {
				while (_file->fragment[--_file->plusoff] == CONTZ) ;
				_file->plusoff++;
				}
			if (_file->plusoff > ngot) ngot=_file->plusoff;
			}

		if (_file->currec >= _file->numrec) {
			_file->numrec=_file->currec;
			_file->plusoff=ngot;
			while (ngot < 128) {
				_file->fragment[ngot++]=CONTZ;
				}
			}
		_cwrite(_file,_file->fragment);
		}
	else if (_file->currec > _file->numrec) {
		if (_file->plusoff == 128 || _file->currec > _file->numrec+1
			|| _file->plusoff == 0) {
			_file->numrec=_file->currec;
			_file->plusoff=0;
			}
		}
	return 0;
	}


/*	GETC, GETW, PUTC, PUTW		*/

getc(filenum)
	int  filenum; {
	int  value;
	int val;
	struct {char byt;};

	value=0;
	filenum &=0x7ff;
	if (_ungotten[filenum] != -1) {
		val=_ungotten[filenum];
		_ungotten[filenum]=-1;
		return val;
		}

	if (filenum <= STDERR) {
#if	IBM
		if (_msdos2) {
			if (_read(filenum,&value,1) == 0) value=26;
			}
		else
#endif
			value=getchar();
		return value == 26 ? -1: value;
		}
	_file=_fileat[filenum-FIRSTD];
	if (_file->bufend > _file->bufnext && _file->dirty == 0) {
		value= ((char *)(_file->bufnext++))->byt;
		}
	else if(read(filenum,&value,1) != 1) return -1;
	if (stopz[filenum] && value == 26) value=-1;
	return value;
	}


getw(filenum)
	int  filenum; {
	int  value;
	struct {char lobyte,hibyte;};

	filenum &=0x7ff;
	if (filenum <= STDERR) {
		(&value)->hibyte=getchar();
		return value+getchar();
		}
	_file=_fileat[filenum-FIRSTD];
	if (_file->bufend > _file->bufnext+1 &&
		 _file->dirty == 0) {
		value=((char *)(_file->bufnext))->loword;
		_file->bufnext+=2;
		return value;
		}
	if (read(filenum,&value,2) != 2) return -1;
	return value;
	}

ungetc(c,filenum)
	int c;
	int filenum; {

	filenum &=0x7ff;
	if (_ungotten[filenum] != -1) c=-1;
	_ungotten[filenum]=c;
	return c;
	}



putc(ch,filenum)
	int  filenum;
	char ch; {
	struct {char byt;};

	filenum &=0x7ff;
	if (filenum <= STDERR) {
#if	IBM
		if (_msdos2 && filenum == STDERR) {
			return _write(filenum,&ch,1);
			}
#endif
		putchar(ch);
		return 0;
		}
	if (filenum == STDPRN) {
		_os(5,ch);
		return 0;
		}
	_file=_fileat[filenum-FIRSTD];
	if (_file->bufend > _file->bufnext+1 && _file->dirty) {
		((char *)(_file->bufnext++))->byt=ch;
		return 0;
		}
	return write(filenum,&ch,1);
	}

putw(wrd,filenum)
	int  filenum;
	int  wrd; {

	return write(filenum,&wrd,2);
	}




/*	FGETS  --	INPUT A LINE FROM A FILE	*/

fgets(str,n,filenum)
	char *str;
	int  n,filenum; {
	int  ch,oldstr;

	filenum &=0x7ff;
	if (filenum <= STDPRN
#if	IBM
		&& _msdos2 == 0
#endif
			)	return gets(str);
	else {
		oldstr=str;
		while (--n && (ch=getc(filenum)) >= 0 && ch != CONTZ) {
			if (ch != CR) *str++=ch;
			if (ch == '\n') break;
			}
		*str=0;
		if (oldstr == str) oldstr=0;
		}
	return oldstr;
	}



/*	FPUTS  --	WRITE A STRING TO A FILE	*/

fputs(str,filenum)
	char *str;
	int  filenum; {
	char ch;

	filenum &=0x7ff;
	if (filenum < STDERR) {
		puts(str);
		return 0;
		}
	while (ch=*str++) {
		if (ch == '\n') if (putc('\r',filenum) == -1) return -1;
		if (putc(ch,filenum) == -1) return -1;
		}
	return 0;
	}





/*	GETS			string address=gets(string address);	*/
static int  getat;

gets(str)
	char *str; {

	_gets(getat=str,512);
	return getat;
	}


/*	_gets	gets with a maximum length	*/

_gets(str,max)
	char str[1];
	int  max; {
	int  numin=0,i;
	char ch;

#if	IBM
	if (_msdos2) {
		numin=fgets(str,max,0);
		if (numin) {
			while (*str) {
				if (*str == '\n') *str=0;		
				str++;
				}
			}
		else getat=0;
		return numin;
		}
#endif

	while (numin < max) {
		ch=ci();
		switch (ch) {
			case CONTC:	puts("*Control C*");
						exit();
			case BS:
			case RUB:	if (numin) {
							numin--;
							putchar('\10');
							putchar(' ');
							putchar('\10');
							}
						break;
			case CONTX:	while (numin) {
							numin--;
							putchar('\10');
							putchar(' ');
							putchar('\10');
							}
						break;
			case CONTZ:	getat=0;
			case LF:
			case CR:	max=0;
						break;
			default:	putchar(ch);
						str[numin++]=ch;
			}
		}
	str[numin]=0;
	putchar('\n');
	return numin;
	}
