/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*
; note: getenv now has length and returns int. findfile added.
; note: locking has long arguments. uses DOS.H.
; note: strscpn: 7 not 1.
; note: FP_OFF and FP_SEG only work in large case
; note: ctime etc.
*/

/*	Mode bits for chdir(). Or the bits desired.	*/

#define	CHDIR_READONLY	1
#define CHDIR_HIDDEN	2

/*	#defines for extraction offset and segment from a pointer.	*/

struct {unsigned _offset,_segment;};
#define FP_OFF(ptr)	((((char *)&ptr))->_offset)
#define FP_SEG(ptr)	((((char *)&ptr))->_segment)

/*	Codes for locking and unlocking. Used by locking().	*/

#define LOCK	0
#define UNLCK	1

/*	Open modes.	*/

#define READ		0
#define WRITE		1
#define READWRITE	2

/*	Open sharing modes. Add to above open modes.	*/

#define COMPAT	0x00	/* compatibility mode */
#define DENYRW	0x10	/* deny read/write mode */
#define DENYWR	0x20	/* deny write mode */
#define DENYRD	0x30	/* deny read mode */
#define DENYNO	0x40	/* deny none mode */

