/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*
 * ldexp returns the quantity (value * 2 ** exp)
 */

#include <errno.h>

double ldexp(value,exp)
double value;
	{
	int *ip;

	ip = &value;
	exp += (ip[3] >> 4) & 0x3FF;
	if(exp < 1)
		value = 0.0;
	else
		if(exp > 0x7FF)
			{
			ip[3] |= 0x7FFF;
			ip[2]  = ip[1] = ip[0] = -1;
			errno  = ERANGE;
			}
	ip[3] = (ip[3] &0x800F) | ((exp << 4) & 0x7FF0);
	return value;
	}
