/*
 *  Released under the GNU LGPL.  See http://www.gnu.org/licenses/lgpl.txt
 *
 *  This program is part of the DeSmet C Compiler
 *
 *  This library is free software * you can redistribute it and/or modify
 *  it under the terms of the GNU Lesser General Public License as published
 *  by the Free Software Foundatation * either version 2.1 of the License, or
 *  any later version.
 *
 *  This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY * without even the implied warranty of MERCHANTABILITY
 *  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 *  License for more details.
 */
/*	LSEEK.C  --		THE C LSEEK ROUTINE	*/


/*	STANDARD FILE NUMBERS	*/

#define	STDIN	0
#define	STDOUT	1
#define	STDERR	2
#define STDPRN	4
#define FIRSTD	5

/*	FILES contains status of all files	*/

/*	CP/M	codes	*/

#define SETDMA_CODE	26
#define RREAD_CODE	33

#define CONTZ	26

#define UNUSED	0
#define	OPENI	1
#define OPENO	2
#define OPENA	3
#define OPENU	4

#define	NFILE	8

#define FDRIVE	0
#define	FNAME	1
#define	FEXT	9
#define	FBLOCK	12
#define FSIZE	16
#define	FRECORD	32
#define	FLOC	33
#define FCBLEN	37
#define	FILELEN	176

extern struct { char mode, plusoff, dirty;
		unsigned bufnext, bufend, currec, numrec;
		char fcb[FCBLEN],fragment[128]; } *_file;

extern char _files[NFILE][FILELEN];
extern unsigned _fileat[NFILE],_msnum[NFILE];

union {long dword; unsigned word;};
struct {unsigned loword,hiword;};
extern int _ungotten[13];
static char zero16[16];
extern char _msdos2;
extern int _oldfile;
long _lseek();


/*	LSEEK			error code = lseek(file number, fileoff, code);
					0=seek from start.
					1=seek from current.
					2=seek from end.			*/

long lseek(filenum,fileoff,code)
	int  filenum;
	long fileoff;
	char code; {
	unsigned recno,num,inum;
	char i,dirt;
	long endloc;

	filenum&=0x7ff;

	if (filenum <= STDPRN || filenum > NFILE+STDPRN || code > 2) return -1L;
	_oldfile=99;		/* nothing in scanf buffer	*/
	_ungotten[filenum]=-1;
	_file=_fileat[filenum-FIRSTD];
	i=_file->mode;
	if (i == UNUSED) return -1L;
	dirt=_file->dirty;
	_fflush(filenum);
	_file->dirty=0;
	if (i == OPENA) _file->mode=OPENU;

	if (_msdos2) {
		if (dirt == 0 && code == 1) fileoff-=_file->bufend-_file->bufnext;
		_file->bufnext=_file->bufend=_file->fragment;
		return _lseek(_msnum[filenum-FIRSTD],fileoff,code);
		}
	if (code == 1) {
		fileoff+=(((long)_file->currec)<<7);
		num=_file->bufnext-&_file->fragment[0];
		if (num) {
			fileoff+=num;
			fileoff-=128;
			}
		}

	if (code == 2 || (fileoff>>7) >= _file->numrec) {
		if (_file->plusoff == 128) {
			(&_file->fcb[FLOC])->dword=_file->numrec;
			_os(SETDMA_CODE,_file->fragment);
			if (_os(RREAD_CODE,_file->fcb) != 0) return -1L;
			i=128;
			while (i && _file->fragment[--i] == CONTZ) ;
			_file->plusoff=i+1;
			}
		}
	if (code == 2) {
		fileoff+=(((long)_file->numrec)<<7)+_file->plusoff;
		}
	if ((&fileoff)->hiword > 256) fileoff=0;

	endloc=(((long)_file->numrec)<<7)+_file->plusoff;

	if (fileoff > endloc) {
		if (lseek(filenum,endloc,0) == -1) return -1L;
		num=fileoff-endloc;
		while (num) {
			inum=num > 16 ? 16: num;
			if (write(filenum,zero16,inum) == -1) return -1L;
			num-=inum;
			}
		return fileoff;
		}
		
	_file->currec=(&_file->fcb[FLOC])->word=fileoff>>7;
	(&_file->fcb[FLOC+2])->word=0;

	_os(SETDMA_CODE,_file->fragment);
	_os(RREAD_CODE,_file->fcb);

	_file->bufnext=_file->bufend=_file->fragment;
	recno=fileoff;
	recno&=127;
	if (recno) {
		num=_cread(_file,_file->fragment);
		_file->bufnext+=recno;
		_file->bufend+=num;
		}
	return fileoff;
	}
